## numpy 2.2.4+ds

=== numpy/_core/src/highway/CMakeLists.txt ===
# Copyright 2019 Google LLC
# Copyright 2024 Arm Limited and/or its affiliates <open-source-office@arm.com>
# SPDX-License-Identifier: Apache-2.0
# SPDX-License-Identifier: BSD-3-Clause
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.10)

# Set PIE flags for POSITION_INDEPENDENT_CODE targets, added in 3.14.
if(POLICY CMP0083)
  cmake_policy(SET CMP0083 NEW)
endif()

# Workaround for 3.19 raising error 'IMPORTED_LOCATION not set for imported
# target "GTest::gtest_main"'.
if(POLICY CMP0111)
  cmake_policy(SET CMP0111 OLD)
endif()

# Starting with GCC-13, we want to make sure to remove gnu extension (ie.
# explicit -std=c++17 instead of implicit `gnu++17`)
# Without this cmake property, CMAKE_CXX_EXTENSIONS=OFF was not properly
# considered
if(POLICY CMP0128)
  cmake_policy(SET CMP0128 NEW)
endif()

project(hwy VERSION 1.2.0)  # Keep in sync with base.h version
# `hwy` is lowercase to handle find_package() in Config mode:
set(namespace "${PROJECT_NAME}::")

# Directly define the ABI version from the cmake project() version values:
set(LIBRARY_VERSION "${hwy_VERSION}")
set(LIBRARY_SOVERSION ${hwy_VERSION_MAJOR})

set(CMAKE_CXX_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
# Search for Atomics implementation:
find_package(Atomics REQUIRED)

# Enabled PIE binaries by default if supported.
include(CheckPIESupported OPTIONAL RESULT_VARIABLE CHECK_PIE_SUPPORTED)
if(CHECK_PIE_SUPPORTED)
  check_pie_supported(LANGUAGES CXX)
  if(CMAKE_CXX_LINK_PIE_SUPPORTED)
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
  endif()
endif()

include(GNUInstallDirs)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# The following is only required with GCC < 6.1.0 or CLANG < 16.0
set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for Armv7 with NEON (requires vfpv4)?")

# This must be set on 32-bit x86 with GCC < 13.1, otherwise math_test will be
# skipped. For GCC 13.1+, you can also build with -fexcess-precision=standard.
set(HWY_CMAKE_SSE2 OFF CACHE BOOL "Set SSE2 as baseline for 32-bit x86?")

# Currently this will compile the entire codebase with `-march=rv<XLEN>gcv1p0`:
set(HWY_CMAKE_RVV ON CACHE BOOL "Set copts for RISCV with RVV?")

# Unconditionally adding -Werror risks breaking the build when new warnings
# arise due to compiler/platform changes. Enable this in CI/tests.
set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")

# Experimental support for header-only builds
set(HWY_CMAKE_HEADER_ONLY OFF CACHE BOOL "Change to header-only?")

set(HWY_ENABLE_CONTRIB ON CACHE BOOL "Include contrib/")
set(HWY_ENABLE_EXAMPLES ON CACHE BOOL "Build examples")
set(HWY_ENABLE_INSTALL ON CACHE BOOL "Install library")
set(HWY_ENABLE_TESTS ON CACHE BOOL "Enable HWY tests")

if (MSVC)
set(HWY_TEST_STANDALONE ON CACHE BOOL "Disable use of googletest")
else()
set(HWY_TEST_STANDALONE OFF CACHE BOOL "Disable use of googletest")
endif()

if (NOT DEFINED CMAKE_CXX_STANDARD)
  if ("cxx_std_17" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
  else()
    if ("cxx_std_14" IN_LIST CMAKE_CXX_COMPILE_FEATURES)
      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
    else()
      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
    endif()
  endif()
else()
  if (CMAKE_CXX_STANDARD GREATER_EQUAL 14 AND CMAKE_CXX_STANDARD LESS 98)
    if (CMAKE_CXX_STANDARD GREATER_EQUAL 17)
      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_17)
    else()
      set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_14)
    endif()
  else()
    set(HWY_CXX_STD_TGT_COMPILE_FEATURE cxx_std_11)
  endif()
endif()

include(CheckCXXSourceCompiles)
check_cxx_source_compiles(
   "int main() {
      #if !defined(__EMSCRIPTEN__)
      static_assert(false, \"__EMSCRIPTEN__ is not defined\");
      #endif
      return 0;
    }"
  HWY_EMSCRIPTEN
)

check_cxx_source_compiles(
   "int main() {
      #if !defined(__riscv)
      static_assert(false, \"__riscv is not defined\");
      #endif
      return 0;
    }"
  HWY_RISCV
)

if (HWY_RISCV OR CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "RISCV32|RISCV64|RISCV128" OR CMAKE_SYSTEM_PROCESSOR MATCHES "riscv32|riscv64|riscv128")
  include(CheckCSourceCompiles)
  check_c_source_compiles("
  #if __riscv_xlen == 64
  int main() { return 0; }
  #else
  #error Not RISCV-64
  #endif
  " IS_RISCV_XLEN_64)

  check_c_source_compiles("
  #if __riscv_xlen == 32
  int main() { return 0; }
  #else
  #error Not RISCV-32
  #endif
  " IS_RISCV_XLEN_32)

  if(IS_RISCV_XLEN_32)
    set(RISCV_XLEN 32)
  elseif(IS_RISCV_XLEN_64)
    set(RISCV_XLEN 64)
  else()
    message(WARNING "Unable to determine RISC-V XLEN")
  endif()
endif()

if (HWY_ENABLE_CONTRIB)
# Glob all the traits so we don't need to modify this file when adding
# additional special cases.
file(GLOB HWY_CONTRIB_SOURCES "hwy/contrib/sort/vqsort_*.cc")
list(APPEND HWY_CONTRIB_SOURCES
    hwy/contrib/bit_pack/bit_pack-inl.h
    hwy/contrib/dot/dot-inl.h
    hwy/contrib/image/image.cc
    hwy/contrib/image/image.h
    hwy/contrib/math/math-inl.h
    hwy/contrib/matvec/matvec-inl.h
    hwy/contrib/random/random-inl.h
    hwy/contrib/sort/order.h
    hwy/contrib/sort/shared-inl.h
    hwy/contrib/sort/sorting_networks-inl.h
    hwy/contrib/sort/traits-inl.h
    hwy/contrib/sort/traits128-inl.h
    hwy/contrib/sort/vqsort-inl.h
    hwy/contrib/sort/vqsort.cc
    hwy/contrib/sort/vqsort.h
    hwy/contrib/thread_pool/futex.h
    hwy/contrib/thread_pool/thread_pool.h
    hwy/contrib/thread_pool/topology.cc
    hwy/contrib/thread_pool/topology.h
    hwy/contrib/algo/copy-inl.h
    hwy/contrib/algo/find-inl.h
    hwy/contrib/algo/transform-inl.h
    hwy/contrib/unroller/unroller-inl.h
)
endif()  # HWY_ENABLE_CONTRIB

set(HWY_SOURCES
    hwy/abort.h
    hwy/aligned_allocator.h
    hwy/base.h
    hwy/cache_control.h
    hwy/detect_compiler_arch.h  # private
    hwy/detect_targets.h  # private
    hwy/foreach_target.h
    hwy/highway_export.h
    hwy/highway.h
    hwy/nanobenchmark.h
    hwy/ops/arm_neon-inl.h
    hwy/ops/arm_sve-inl.h
    hwy/ops/emu128-inl.h
    hwy/ops/generic_ops-inl.h
    hwy/ops/inside-inl.h
    hwy/ops/ppc_vsx-inl.h
    hwy/ops/rvv-inl.h
    hwy/ops/scalar-inl.h
    hwy/ops/set_macros-inl.h
    hwy/ops/shared-inl.h
    hwy/ops/wasm_128-inl.h
    hwy/ops/x86_128-inl.h
    hwy/ops/x86_256-inl.h
    hwy/ops/x86_512-inl.h
    hwy/ops/x86_avx3-inl.h
    hwy/per_target.h
    hwy/print-inl.h
    hwy/print.h
    hwy/profiler.h
    hwy/robust_statistics.h
    hwy/targets.h
    hwy/timer-inl.h
    hwy/timer.h
)

if (NOT HWY_CMAKE_HEADER_ONLY)
  list(APPEND HWY_SOURCES
    hwy/abort.cc
    hwy/aligned_allocator.cc
    hwy/nanobenchmark.cc
    hwy/per_target.cc
    hwy/perf_counters.cc
    hwy/print.cc
    hwy/targets.cc
    hwy/timer.cc
  )
endif()

set(HWY_TEST_SOURCES
    hwy/tests/hwy_gtest.h
    hwy/tests/test_util-inl.h
    hwy/tests/test_util.cc
    hwy/tests/test_util.h
)

if (MSVC)
  set(HWY_FLAGS
    # fix build error C1128 in blockwise*_test & arithmetic_test
    /bigobj

    # Warnings
    /W4
    # Disable some W4 warnings.  Enable them individually after they are cleaned up.
    /wd4100
    /wd4127
    /wd4324
    /wd4456
    /wd4701
    /wd4702
    /wd4723

    # CMake automatically adds exception handling flags.  Remove them.
    /GR-
    /EHs-c-
    # Disable exceptions in STL code.
    -D_HAS_EXCEPTIONS=0
  )

  # This adds extra warnings for the clang-cl compiler on Windows.
  # This is the same as the sections in the else part.
  # These could be refactored.
  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    list(APPEND HWY_FLAGS
      # These are not included in Wall nor Wextra:
      -Wconversion
      -Wsign-conversion
      -Wvla
      -Wnon-virtual-dtor

      -Wfloat-overflow-conversion
      -Wfloat-zero-conversion
      -Wfor-loop-analysis
      -Wgnu-redeclared-enum
      -Winfinite-recursion
      -Wself-assign
      -Wstring-conversion
      -Wtautological-overlap-compare
      -Wthread-safety-analysis
      -Wundefined-func-template
    )
  endif()

  if (HWY_WARNINGS_ARE_ERRORS)
    list(APPEND HWY_FLAGS /WX)
  endif()
else()
  set(HWY_FLAGS
    # Avoid changing binaries based on the current time and date.
    -Wno-builtin-macro-redefined
    -D__DATE__="redacted"
    -D__TIMESTAMP__="redacted"
    -D__TIME__="redacted"

    # Optimizations
    -fmerge-all-constants

    # Warnings
    -Wall
    -Wextra
    # These are not included in Wall nor Wextra:
    -Wconversion
    -Wsign-conversion
    -Wvla
    -Wnon-virtual-dtor
    -Wcast-align # see -Wcast-align=strict on x86
  )

  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    list(APPEND HWY_FLAGS
      -Wfloat-overflow-conversion
      -Wfloat-zero-conversion
      -Wfor-loop-analysis
      -Wgnu-redeclared-enum
      -Winfinite-recursion
      -Wself-assign
      -Wstring-conversion
      -Wtautological-overlap-compare
      -Wthread-safety-analysis
      -Wundefined-func-template

      -fno-cxx-exceptions
      -fno-slp-vectorize
      -fno-vectorize

      # Use color in messages
      -fdiagnostics-show-option -fcolor-diagnostics
    )
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
      list(APPEND HWY_FLAGS -Wc++2a-extensions)
    endif()
  endif()

  if (WIN32)
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
      list(APPEND HWY_FLAGS
        -Wno-global-constructors
        -Wno-language-extension-token
        -Wno-used-but-marked-unused
        -Wno-shadow-field-in-constructor
        -Wno-unused-member-function
        -Wno-unused-template
        -Wno-c++98-compat-pedantic
        -Wno-used-but-marked-unused
        -Wno-zero-as-null-pointer-constant
      )
    endif()

    list(APPEND HWY_FLAGS
      -Wno-cast-align
      -Wno-double-promotion
      -Wno-float-equal
      -Wno-format-nonliteral
      -Wno-shadow
      -Wno-sign-conversion
    )
  else()
    list(APPEND HWY_FLAGS
      -fmath-errno
      -fno-exceptions
    )
  endif()  # WIN32

  # Workaround for excess precision, see #1488.
  if (HWY_CMAKE_SSE2)
    list(APPEND HWY_FLAGS -msse2 -mfpmath=sse)
  endif()

  # Suppress STL iterator warnings. Supported by GCC 4.4.7 and newer, which
  # predates the C++11 we require.
  if (${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
    list(APPEND HWY_FLAGS -Wno-psabi)
  endif()
  # Clang supports this flag from 11.0.
  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 11.0)
      list(APPEND HWY_FLAGS -Wno-psabi)
    endif()
  endif()

  if (HWY_CMAKE_ARM7)
    list(APPEND HWY_FLAGS
      -march=armv7-a
      -mfpu=neon-vfpv4
      -mfloat-abi=hard  # must match the toolchain specified as CXX=
    )
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
      # using GCC
      list(APPEND HWY_FLAGS
        -mfp16-format=ieee  # required for vcvt_f32_f16
      )
    endif()
  endif()  # HWY_CMAKE_ARM7

  if(HWY_RISCV)
    # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
    # we add the gcv compiler flag, which then requires the CPU (now when using
    # either compiler) to support V.
    if(HWY_CMAKE_RVV)
      if(RISCV_XLEN EQUAL 64)
        list(APPEND HWY_FLAGS -march=rv64gcv1p0)
        add_link_options(-march=rv64gcv1p0)
      elseif(RISCV_XLEN EQUAL 32)
        list(APPEND HWY_FLAGS -march=rv32gcv1p0)
        add_link_options(-march=rv32gcv1p0)
      endif()
      if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")

=== numpy/_core/src/npysort/x86-simd-sort/Makefile ===
test:
	meson setup -Dbuild_tests=true -Duse_openmp=false --warnlevel 2 --werror --buildtype release builddir
	cd builddir && ninja

test_openmp:
	meson setup -Dbuild_tests=true -Duse_openmp=true --warnlevel 2 --werror --buildtype release builddir
	cd builddir && ninja

bench:
	meson setup -Dbuild_benchmarks=true --warnlevel 2 --werror --buildtype release builddir
	cd builddir && ninja

debug:
	meson setup -Dbuild_tests=true --warnlevel 2 --werror --buildtype debug debug
	cd debug && ninja

sharedlib:
	meson setup --warnlevel 2 --werror --buildtype release builddir
	cd builddir && ninja

install:
	meson setup --warnlevel 2 --werror --buildtype release builddir
	cd builddir && meson install

clean:
	$(RM) -rf $(TESTOBJS) $(BENCHOBJS) $(UTILOBJS) testexe benchexe builddir debug

=== numpy/_core/src/npysort/x86-simd-sort/meson_options.txt ===
option('build_tests', type : 'boolean', value : false,
  description : 'Build test suite (default: "false").')
option('build_benchmarks', type : 'boolean', value : false,
  description : 'Build benchmarking suite (default: "false").')
option('build_ippbench', type : 'boolean', value : false,
  description : 'Add IPP sort to benchmarks (default: "false").')
option('build_vqsortbench', type : 'boolean', value : true,
  description : 'Add google vqsort to benchmarks (default: "true").')
option('use_openmp', type : 'boolean', value : false,
  description : 'Use OpenMP to accelerate key-value sort (default: "false").')

=== vendored-meson/meson/test cases/common/197 function attributes/meson_options.txt ===
option(
    'mode',
    type : 'combo',
    choices : ['single', 'parallel'],
    value : 'single',
    description : 'Test the one at a time function or many at a time function.'
)

=== vendored-meson/meson/test cases/cmake/24 mixing languages/subprojects/cmTest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(cmTest LANGUAGES C OBJC)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(cmTest STATIC cmTest.c cmTest.m)
target_compile_definitions(cmTest PUBLIC SOME_MAGIC_DEFINE=42)

=== vendored-meson/meson/test cases/cmake/27 dependency fallback/subprojects/cmMod/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(cmMod VERSION 1.2.3)
set(CMAKE_CXX_STANDARD 14)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_definitions("-DDO_NOTHING_JUST_A_FLAG=1")

add_library(cmModLib++ SHARED cmMod.cpp)
target_compile_definitions(cmModLib++ PRIVATE MESON_MAGIC_FLAG=21)
target_compile_definitions(cmModLib++ INTERFACE MESON_MAGIC_FLAG=42)

# Test PCH support
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
    target_precompile_headers(cmModLib++ PRIVATE "cpp_pch.hpp")
endif()

include(GenerateExportHeader)
generate_export_header(cmModLib++)

=== debian/changelog ===
numpy (1:2.2.4+ds-1ubuntu1) questing; urgency=medium

  * Rebuild for IEEE long double on ppc64el
  * Skip test_linear_interpolation_formula_symmetric and
    test_ppc64_ibm_double_double128 on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 01 Jun 2025 12:18:42 +0000

numpy (1:2.2.4+ds-1) unstable; urgency=medium

  * New upstream version 2.2.4+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 01 Apr 2025 21:45:23 +0200

numpy (1:2.2.3+ds-5) unstable; urgency=medium

  * Fix reproducibility issues with object files again

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Mar 2025 21:14:24 +0100

numpy (1:2.2.3+ds-4) unstable; urgency=medium

  * Add --force option to dh_numpy3 and improve detection
  * Fix FTBFS on alpha and hurd-*

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Mar 2025 22:25:17 +0100

numpy (1:2.2.3+ds-3) unstable; urgency=medium

  * Make dh_numpy3 smarter about adding ABI dependencies
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Fri, 28 Feb 2025 14:47:44 +0100

=== debian/control ===
Source: numpy
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Christian Kastner <ckk@debian.org>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cython3:native (>= 3.0),
 gfortran [amd64 arm64 ppc64el] <!nocheck>,
 libblas-dev [!arm !m68k],
 liblapack-dev [!arm !m68k],
 libpython3-all-dev,
 mypy <!nocheck>,
 ninja-build,
 pkgconf <!nocheck>,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-charset-normalizer <!nocheck>,
 python3-hypothesis <!nocheck>,
 python3-mesonpy:native,
 python3-pyproject-metadata:native,
 python3-pytest <!nocheck>,
 python3-pytest-xdist <!nocheck>,
 python3-setuptools <!nocheck>,
 python3-typing-extensions (>= 4.2.0) <!nocheck>,
 python3-tz <!nocheck>,
 tzdata-legacy <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 doxygen <!nodoc>,
 python-imageio-doc <!nodoc>,
 python-pandas-doc <!nodoc>,
 python-pytest-doc <!nodoc>,
 python-scipy-doc <!nodoc>,
 python-skimage-doc <!nodoc>,
 python3-breathe <!nodoc>,
 python3-doc <!nodoc>,
 python3-ipython <!nodoc>,
 python3-numpydoc <!nodoc>,
 python3-pickleshare <!nodoc>,
 python3-pydata-sphinx-theme <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
 python3-sphinx-design <!nodoc>,
# python-matplotlib-doc <!nodoc>,  # missing
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/python-team/packages/numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/numpy
Homepage: http://www.numpy.org/
Testsuite: autopkgtest-pkg-pybuild
Description: Python library for numerical computations
 NumPy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.

Package: python3-numpy
Architecture: any
Multi-Arch: allowed
Pre-Depends:
 dpkg (>= 1.17.14),
Depends:
 python3-numpy-dev (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 gcc,
 gfortran,
 python-numpy-doc,
 python3-dev,
 python3-pytest,
Provides:
 python3-f2py,
 ${numpy3:Provides},
 ${python3:Provides},
Description: ${source:Synopsis} (Python 3)
 ${source:Extended-Description}
 .
 This package installs NumPy for Python 3.

Package: python-numpy-doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 python-imageio-doc,
 python-pandas-doc,
 python-pytest-doc,
 python-scipy-doc,
 python-skimage-doc,
 python3-doc,
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: ${source:Synopsis} (Documentation)
 ${source:Extended-Description}
 .
 This package contains documentation for NumPy and f2py.

Package: python3-numpy-dev
Architecture: any
Multi-Arch: same
Breaks:
 python3-numpy (<< 1:2.1.3+ds-1~),
Replaces:
 python3-numpy (<< 1:2.1.3+ds-1~),
Depends:
 ${misc:Depends},
Recommends:
 python3-numpy,
Provides:
 dh-sequence-numpy3,
Description: ${source:Synopsis} (Python 3 headers)
 ${source:Extended-Description}
 .
 This package installs the development headers which are needed
 to build C/C++ extensions with NumPy for Python 3.

## numpy 2.3.2+ds

=== debian/changelog ===
numpy (1:2.3.2+ds-1) experimental; urgency=medium

  * New upstream version 2.3.2+ds
  * Update patches.
    Obsolete: 0007-Disable-plots-to-avoid-circular-NumPy-dependency.patch
  * Reintroduce python3-matplotlib dependency for documentation
  * Downgrade dh_numpy3 skip warning to a info message
  * Make random numbers in documentation reproducible
  * Skip numpy-config tests in test suite
  * Bump C API version to 20
  * Acknowledge NMUs for IEEE long double format change on ppc64el
  * Update cross-build helper to reflect said format change

 -- Timo Röhling <roehling@debian.org>  Mon, 08 Sep 2025 08:12:27 +0200

numpy (1:2.2.4+ds-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Skip two tests for IEEE long double on ppc64el (Graham Inggs).
    Closes: #1113967.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Sep 2025 11:56:25 +0200

numpy (1:2.2.4+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:17:01 +0200

## numpy 2.3.3%2Bds

=== vendored-meson/meson/test cases/failing/56 bad option argument/meson_options.txt ===
option('name', type : 'string', value_ : 'foo')

## numpy 2.3.3+ds

=== tools/swig/Makefile ===
# List all of the subdirectories here for recursive make
SUBDIRS = test

# Default target
.PHONY : default
default:
	@echo "There is no default make target for this Makefile"
	@echo "Valid make targets are:"
	@echo "    test           - Compile and run tests of numpy.i"
	@echo "    doc            - Generate numpy.i documentation"
	@echo "    all            - make test + doc"
	@echo "    clean          - Remove generated files recursively"

# Target all
.PHONY : all
all: $(SUBDIRS)

# Target test
.PHONY : test
test:
	cd $@ && make $@

# Target clean
.PHONY : clean
clean:
	@for dir in $(SUBDIRS); do                \
	    echo ;                                \
	    echo Running \'make clean\' in $$dir; \
	    cd $$dir && make clean && cd ..;      \
	done;                                     \
	echo

=== numpy/_core/src/highway/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,14 @@
 # The following is only required with GCC < 6.1.0 or CLANG < 16.0
 set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for Armv7 with NEON (requires vfpv4)?")
 
+# Upstream compilers(GCC 14 or CLANG 18) start enabling LSX by default, but
+# enabling LASX still require -mlasx flag to be passed explicitly, in order
+# to enable all targets, we can check them directly, adding them if they are
+# supported.  In this way, Our local compilers(GCC 8.3.0 or CLANG 8.0.1) also
+# could enable LSX & LASX targets.  Any better ideas or suggestions are welcome.
+set(HWY_CMAKE_LSX ON CACHE BOOL "Add -mlsx flag?")
+set(HWY_CMAKE_LASX ON CACHE BOOL "Add -mlasx flag?")
+
 # This must be set on 32-bit x86 with GCC < 13.1, otherwise math_test will be
 # skipped. For GCC 13.1+, you can also build with -fexcess-precision=standard.
 set(HWY_CMAKE_SSE2 OFF CACHE BOOL "Set SSE2 as baseline for 32-bit x86?")
@@ -135,6 +143,89 @@
     }"
   HWY_RISCV
 )
+
+if (CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch32|loongarch64")
+  include(CheckCXXCompilerFlag)
+  if (HWY_CMAKE_LSX)
+    set (CMAKE_REQUIRED_FLAGS -mlsx)
+    check_cxx_source_compiles(
+       "int main() {
+          #if !defined(__loongarch_sx)
+          static_assert(false, \"__loongarch_sx is not defined\");
+          #endif
+          return 0;
+        }"
+      COMPILER_SUPPORT_LSX_FLAG
+    )
+  endif()
+  if (HWY_CMAKE_LASX)
+    set (CMAKE_REQUIRED_FLAGS -mlasx)
+    check_cxx_source_compiles(
+       "int main() {
+          #if !defined(__loongarch_asx)
+          static_assert(false, \"__loongarch_asx is not defined\");
+          #endif
+          return 0;
+       }"
+      COMPILER_SUPPORT_LASX_FLAG
+    )
+  endif()
+endif()
+
+if (WIN32)
+  set (ORIG_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
+  set (CMAKE_REQUIRED_LIBRARIES synchronization)
+  check_cxx_source_compiles(
+    "#ifndef NOMINMAX
+     #define NOMINMAX
+     #endif
+
+     #include <windows.h>
+
+     int main() {
+       unsigned val1 = 0u;
+       unsigned val2 = 1u;
+       WaitOnAddress(&val1, &val2, sizeof(unsigned), 1);
+       WakeByAddressAll(&val1);
+       WakeByAddressSingle(&val1);
+       return 0;
+     }"
+  HWY_HAVE_WIN32_SYNCHRONIZATION_LIB)
+  set (CMAKE_REQUIRED_LIBRARIES ${ORIG_CMAKE_REQUIRED_LIBRARIES})
+else()
+  set (HWY_HAVE_WIN32_SYNCHRONIZATION_LIB OFF)
+endif ()
+
+if (HWY_HAVE_WIN32_SYNCHRONIZATION_LIB OR NOT WIN32)
+  set (HWY_DISABLE_FUTEX OFF CACHE BOOL "Disable futex for thread_pool")
+else()
+  # Force HWY_DISABLE_FUTEX to ON if compiling for Win32 and
+  # libsynchronization.a or synchronization.lib is not available
+  set (HWY_DISABLE_FUTEX ON CACHE BOOL "Disable futex for thread_pool" FORCE)
+endif()
+
+find_package(Threads)
+
+if (NOT Threads_FOUND AND HWY_ENABLE_CONTRIB)
+  message(FATAL_ERROR "Threads must be available if HWY_ENABLE_CONTRIB is ON")
+endif()
+
+if(Threads_FOUND)
+  if(THREADS_HAVE_PTHREAD_ARG)
+    set(HWY_THREAD_FLAGS "-pthread")
+  else()
+    set(HWY_THREAD_FLAGS "")
+  endif()
+
+  if(CMAKE_THREAD_LIBS_INIT)
+    set(HWY_THREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
+  else()
+    set(HWY_THREAD_LIBS "")
+  endif()
+else()
+  set(HWY_THREAD_FLAGS "")
+  set(HWY_THREAD_LIBS "")
+endif()
 
 if (HWY_RISCV OR CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "RISCV32|RISCV64|RISCV128" OR CMAKE_SYSTEM_PROCESSOR MATCHES "riscv32|riscv64|riscv128")
   include(CheckCSourceCompiles)
@@ -184,6 +275,7 @@
     hwy/contrib/sort/vqsort.cc
     hwy/contrib/sort/vqsort.h
     hwy/contrib/thread_pool/futex.h
+    hwy/contrib/thread_pool/spin.h
     hwy/contrib/thread_pool/thread_pool.h
     hwy/contrib/thread_pool/topology.cc
     hwy/contrib/thread_pool/topology.h
@@ -197,6 +289,7 @@
 set(HWY_SOURCES
     hwy/abort.h
     hwy/aligned_allocator.h
+    hwy/auto_tune.h
     hwy/base.h
     hwy/cache_control.h
     hwy/detect_compiler_arch.h  # private
@@ -210,6 +303,8 @@
     hwy/ops/emu128-inl.h
     hwy/ops/generic_ops-inl.h
     hwy/ops/inside-inl.h
+    hwy/ops/loongarch_lsx-inl.h
+    hwy/ops/loongarch_lasx-inl.h
     hwy/ops/ppc_vsx-inl.h
     hwy/ops/rvv-inl.h
     hwy/ops/scalar-inl.h
@@ -228,6 +323,7 @@
     hwy/targets.h
     hwy/timer-inl.h
     hwy/timer.h
+    hwy/x86_cpuid.h
 )
 
 if (NOT HWY_CMAKE_HEADER_ONLY)
@@ -238,6 +334,7 @@
     hwy/per_target.cc
     hwy/perf_counters.cc
     hwy/print.cc
+    hwy/profiler.cc
     hwy/targets.cc
     hwy/timer.cc
   )
@@ -322,102 +419,3 @@
     -Wcast-align # see -Wcast-align=strict on x86
   )
 
-  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-    list(APPEND HWY_FLAGS
-      -Wfloat-overflow-conversion
-      -Wfloat-zero-conversion
-      -Wfor-loop-analysis
-      -Wgnu-redeclared-enum
-      -Winfinite-recursion
-      -Wself-assign
-      -Wstring-conversion
-      -Wtautological-overlap-compare
-      -Wthread-safety-analysis
-      -Wundefined-func-template
-
-      -fno-cxx-exceptions
-      -fno-slp-vectorize
-      -fno-vectorize
-
-      # Use color in messages
-      -fdiagnostics-show-option -fcolor-diagnostics
-    )
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
-      list(APPEND HWY_FLAGS -Wc++2a-extensions)
-    endif()
-  endif()
-
-  if (WIN32)
-    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-      list(APPEND HWY_FLAGS
-        -Wno-global-constructors
-        -Wno-language-extension-token
-        -Wno-used-but-marked-unused
-        -Wno-shadow-field-in-constructor
-        -Wno-unused-member-function
-        -Wno-unused-template
-        -Wno-c++98-compat-pedantic
-        -Wno-used-but-marked-unused
-        -Wno-zero-as-null-pointer-constant
-      )
-    endif()
-
-    list(APPEND HWY_FLAGS
-      -Wno-cast-align
-      -Wno-double-promotion
-      -Wno-float-equal
-      -Wno-format-nonliteral
-      -Wno-shadow
-      -Wno-sign-conversion
-    )
-  else()
-    list(APPEND HWY_FLAGS
-      -fmath-errno
-      -fno-exceptions
-    )
-  endif()  # WIN32
-
-  # Workaround for excess precision, see #1488.
-  if (HWY_CMAKE_SSE2)
-    list(APPEND HWY_FLAGS -msse2 -mfpmath=sse)
-  endif()
-
-  # Suppress STL iterator warnings. Supported by GCC 4.4.7 and newer, which
-  # predates the C++11 we require.
-  if (${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
-    list(APPEND HWY_FLAGS -Wno-psabi)
-  endif()
-  # Clang supports this flag from 11.0.
-  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 11.0)
-      list(APPEND HWY_FLAGS -Wno-psabi)
-    endif()
-  endif()
-
-  if (HWY_CMAKE_ARM7)
-    list(APPEND HWY_FLAGS
-      -march=armv7-a
-      -mfpu=neon-vfpv4
-      -mfloat-abi=hard  # must match the toolchain specified as CXX=
-    )
-    if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
-      # using GCC
-      list(APPEND HWY_FLAGS
-        -mfp16-format=ieee  # required for vcvt_f32_f16
-      )
-    endif()
-  endif()  # HWY_CMAKE_ARM7
-
-  if(HWY_RISCV)
-    # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
-    # we add the gcv compiler flag, which then requires the CPU (now when using
-    # either compiler) to support V.
-    if(HWY_CMAKE_RVV)
-      if(RISCV_XLEN EQUAL 64)
-        list(APPEND HWY_FLAGS -march=rv64gcv1p0)
-        add_link_options(-march=rv64gcv1p0)
-      elseif(RISCV_XLEN EQUAL 32)
-        list(APPEND HWY_FLAGS -march=rv32gcv1p0)
-        add_link_options(-march=rv32gcv1p0)
-      endif()
-      if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")

=== vendored-meson/meson/test cases/common/192 feature option/meson_options.txt ===
option('required', type : 'feature', value : 'enabled', description : 'An required feature')
option('optional', type : 'feature', value : 'auto', description : 'An optional feature')
option('disabled', type : 'feature', value : 'disabled', description : 'A disabled feature')

=== vendored-meson/meson/test cases/failing/14 invalid option name/meson_options.txt ===
option('invalid:name', type : 'boolean', value : false)

=== vendored-meson/meson/test cases/unit/125 declare_dep var/meson_options.txt ===
option('dir', type: 'string')

=== vendored-meson/meson/test cases/unit/39 external, internal library rpath/built library/meson_options.txt ===
option('foo_system_path', type: 'string', value: '')

=== vendored-meson/meson/test cases/cmake/8 custom command/subprojects/cmMod/CMakeLists.txt ===
cmake_minimum_required(VERSION ${CMAKE_VERSION})

project(cmMod)
set (CMAKE_CXX_STANDARD 14)
set (CMAKE_CXX_STANDARD_REQUIRED ON)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_definitions("-DDO_NOTHING_JUST_A_FLAG=1")

add_executable(genMain genMain.cpp)
add_custom_command(OUTPUT main.cpp COMMAND genMain > main.cpp)

add_executable(gen main.cpp)
add_executable(mycpy cp.cpp)

# cpyBase
add_custom_command(
  OUTPUT  "${CMAKE_CURRENT_BINARY_DIR}/genTest.cpp" "${CMAKE_CURRENT_BINARY_DIR}/genTest.hpp"
  COMMAND gen ARGS genTest
)

set(CMD_PART)
list(APPEND CMD_PART COMMAND mycpy cpyBase.cpp.in     cpyBase.cpp.in.gen)
list(APPEND CMD_PART COMMAND mycpy cpyBase.cpp.in.gen cpyBase.cpp.out)
list(APPEND CMD_PART COMMAND mycpy cpyBase.cpp.out    cpyBase.cpp.something)

add_custom_command(
  OUTPUT cpyBase.cpp
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyBase.cpp.am" cpyBase.cpp.in
  ${CMD_PART}
  COMMAND mycpy cpyBase.cpp.in                               cpyBase.cpp.something
  COMMAND mycpy cpyBase.cpp.something                        cpyBase.cpp.IAmRunningOutOfIdeas
  COMMAND mycpy cpyBase.cpp.IAmRunningOutOfIdeas             cpyBase.cpp
  DEPENDS cpyBase.cpp.am;gen
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyBase.hpp.in"
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyBase.hpp.am" cpyBase.hpp.in
  DEPENDS cpyBase.hpp.am
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyBase.hpp.something"
  COMMAND mycpy cpyBase.hpp.in                               cpyBase.hpp.something
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/cpyBase.hpp.in"
)

# Slight tuning to the file extension (it's still a C++ header)
# checks that file extensions are not considered for the purposes
# of target dependencies
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyBase.txt"
  COMMAND mycpy cpyBase.hpp.something                        cpyBase.txt
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/cpyBase.hpp.something"
)

# cpyNext (out of order is on purpose)
# -- first copy round
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/s1_a_hpp/file.txt"
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyNext.hpp.am" file.txt
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyNext.hpp.am"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/s1_a_hpp"
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/s1_b_cpp/file.txt"
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyNext.cpp.am" file.txt
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyNext.cpp.am"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/s1_b_cpp"
)

# -- final cpy round
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyNext.hpp"
  COMMAND mycpy "${CMAKE_CURRENT_BINARY_DIR}/s2_b_hpp/file.txt" cpyNext.hpp
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/s2_b_hpp/file.txt"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyNext.cpp"
  COMMAND mycpy "${CMAKE_CURRENT_BINARY_DIR}/s2_a_cpp/file.txt" cpyNext.cpp
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/s2_a_cpp/file.txt"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

# -- second copy round
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/s2_b_hpp/file.txt"
  COMMAND mycpy "${CMAKE_CURRENT_BINARY_DIR}/s1_a_hpp/file.txt" file.txt
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/s1_a_hpp/file.txt"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/s2_b_hpp"
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/s2_a_cpp/file.txt"
  COMMAND mycpy "${CMAKE_CURRENT_BINARY_DIR}/s1_b_cpp/file.txt" file.txt
  DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/s1_b_cpp/file.txt"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/s2_a_cpp"
)

# cpyTest (copy file without renaming)
add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyTest.hpp"
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest.hpp" "${CMAKE_CURRENT_BINARY_DIR}/cpyTest.hpp"
  DEPENDS "cpyTest/cpyTest.hpp"
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyTest2.hpp"
  COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest2.hpp" "${CMAKE_CURRENT_BINARY_DIR}/cpyTest2.hpp"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest2.hpp"
)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyTest3.hpp"
  COMMAND mycpy cpyTest3.hpp "${CMAKE_CURRENT_BINARY_DIR}/cpyTest3.hpp"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest3.hpp"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest"
)

add_subdirectory(cpyTest ccppyyTTeesstt)

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyTest/some/directory/cpyTest5.hpp"
  COMMAND ${CMAKE_COMMAND} -E copy "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest5.hpp" "${CMAKE_CURRENT_BINARY_DIR}/cpyTest/some/directory/cpyTest5.hpp"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyTest/cpyTest5.hpp"
)
include_directories("${CMAKE_CURRENT_BINARY_DIR}/cpyTest/some")

add_library(cmModLib SHARED cmMod.cpp genTest.cpp cpyBase.cpp cpyBase.txt cpyNext.cpp cpyNext.hpp cpyTest.cpp cpyTest.hpp cpyTest2.hpp cpyTest3.hpp cpyTest/some/directory/cpyTest5.hpp)
include(GenerateExportHeader)
generate_export_header(cmModLib)

set(ARGS_TEST arg1)
set(ARGS_TEST ${ARGS_TEST} arg2)

add_executable(macro_name macro_name.cpp)
add_executable(args_test args_test.cpp)
add_custom_target(args_test_cmd
  COMMAND args_test ${ARGS_TEST}
)
add_custom_target(macro_name_cmd COMMAND macro_name)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  message(STATUS "Running the -include test case on macro_name")
  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/cpyInc.hpp"
    COMMAND mycpy "${CMAKE_CURRENT_SOURCE_DIR}/cpyInc.hpp.am" "${CMAKE_CURRENT_BINARY_DIR}/cpyInc.hpp"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/cpyInc.hpp.am"
  )
  target_compile_options(macro_name PUBLIC -DTEST_CMD_INCLUDE -include "${CMAKE_CURRENT_BINARY_DIR}/cpyInc.hpp")
endif()

# Only executable targets are replaced in the command
# all other target names are kept as is
add_custom_target(clang-format COMMAND clang-format -i cmMod.cpp)

add_dependencies(cmModLib args_test_cmd tgtCpyTest4)
add_dependencies(args_test_cmd macro_name_cmd;gen;mycpy)

# Reproduce https://github.com/mesonbuild/meson/issues/10244
add_custom_target(mycpy.all)
add_dependencies(mycpy.all mycpy)

=== vendored-meson/meson/test cases/rust/22 cargo subproject/subprojects/extra-dep-1-rs/meson_options.txt ===
option('feature-default', type: 'boolean', value: true)

=== debian/changelog ===
numpy (1:2.3.3+ds-3ubuntu1) resolute; urgency=medium

  * Skip test_cpu_features on ppc64el and s390x (LP: #2127939)

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 14:38:40 +0000

numpy (1:2.3.3+ds-3) unstable; urgency=medium

  * Reproducible Builds fix
  * Monkeypatch numpy.random.default_rng for reproducible documentation
  * Do not run %timeit during documentation build

 -- Timo Röhling <roehling@debian.org>  Fri, 10 Oct 2025 12:42:48 +0200

numpy (1:2.3.3+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Skip test that fails on armel

 -- Timo Röhling <roehling@debian.org>  Thu, 09 Oct 2025 10:05:50 +0200

numpy (1:2.3.3+ds-1) experimental; urgency=medium

  * New upstream version 2.3.3+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 12:49:37 +0200

=== debian/control ===
--- 
+++ 
@@ -40,6 +40,7 @@
  python3-breathe <!nodoc>,
  python3-doc <!nodoc>,
  python3-ipython <!nodoc>,
+ python3-matplotlib <!nodoc>,
  python3-numpydoc <!nodoc>,
  python3-pickleshare <!nodoc>,
  python3-pydata-sphinx-theme <!nodoc>,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Large file support actually works, but some buildds and Salsa do not like us
# creating 5 GB files.
SKIP_TESTS = \
	test_big_arrays \
	test_large_file_support \
	test_configtool
# Some tests have architecture-specific issues. Generally, these are related to
# unexpected behavior of floating point operations (unexpected for the unit
# tests, that is).
ifneq ($(filter armel armhf,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	FPClass \
	SpecialFloats \
	TestBoolCmp \
	error \
	except \
	overflow \
	test_denormal_numbers \
	test_divide_err \
	test_empty \
	test_exotic \
	test_features \
	test_half_fpe \
	test_linear_interpolation_formula_symmetric \
	test_log2_special \
	test_nonarray_assignment \
	test_special_values \
	test_where \
	test_zero_power_nonzero
endif
# The huge vector exceeds the available address space on 32 bit architectures
ifeq ($(DEB_HOST_ARCH_BITS),32)
SKIP_TESTS += \
	test_huge_vectordot
endif
ifneq ($(filter armel,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	test_dot_errstate
endif
ifneq ($(filter mips64el,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	NanFunctions \
	SpecialComplex \
	SpecialFloats \
	error \
	test_reduce
endif
ifneq ($(filter alpha mips64el powerpc ppc64 sparc64,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	sq_cases
endif
ifneq ($(filter hppa powerpc,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	ctypeslib \
	test_dtype
endif
ifneq ($(filter powerpc,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	test_linalg
endif
ifneq ($(filter ppc64el,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
    test_cpu_features \
    test_ppc64_ibm_double_double128 \
    test_linear_interpolation_formula_symmetric
endif
ifneq ($(filter s390x,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
    test_cpu_features
endif
ifeq ($(PYBUILD_AUTOPKGTEST),1)
SKIP_TESTS += test_dict_mode
endif

export PYBUILD_BUILD_ARGS = --config-setting build-dir={dir}/.mesonpy
export PYBUILD_TEST_ARGS = $(if $(SKIP_TESTS),-k 'not ($(call concat_with,$(space)or$(space),$(SKIP_TESTS)))')
ifeq ($(PYBUILD_AUTOPKGTEST),1)
PYBUILD_TEST_ARGS += /usr/lib/python3/dist-packages/numpy
endif

ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
export PYBUILD_BEFORE_BUILD = meson env2mfile --debarch $(DEB_HOST_ARCH) --cross -o {dir}/debian/meson-cross.txt \
	&& python3 {dir}/debian/helpers/add_longdouble_format_property.py {dir}/debian/meson-cross.txt $(DEB_HOST_ARCH)
export PYBUILD_AFTER_BUILD = rm {dir}/debian/meson-cross.txt
PYBUILD_BUILD_ARGS += --config-setting setup-args=--cross-file={dir}/debian/meson-cross.txt
endif

# Helper variables
PY3VERS = $(shell py3versions -vr)
PY3DEF = $(shell py3versions -vd)
STAGING_DIR = $(CURDIR)/debian/tmp
PYTHON3_NUMPY_DIR = $(CURDIR)/debian/python3-numpy
space = $(eval) $(eval)
concat_with = $(subst $(space),$1,$2)

%:
	dh $@ --buildsystem=pybuild

auto-build-for-default-python:
	PYBUILD_DISABLE="$(filter-out $(PY3DEF),$(PY3VERS))" dh_auto_build
	touch $@

auto-build-for-other-python:
	PYBUILD_DISABLE="$(PY3DEF)" dh_auto_build
	touch $@

override_dh_auto_build-arch: auto-build-for-default-python auto-build-for-other-python
	true

override_dh_auto_build-indep: auto-build-for-default-python
	$(MAKE) -C doc html \
		GITVER=Unknown \
		MPLCONFIGDIR=. \
		SPHINXOPTS= \
		PYTHON=python3 \
		PYTHONPATH=$(shell pybuild --print {build_dir} --interpreter python3)

# Nothing to install for -indep
override_dh_auto_install-indep:

# No tests to run for the -doc package
override_dh_auto_test-indep:

override_dh_auto_test-arch:
	dh_auto_test --arch -O--buildsystem=pybuild

execute_after_dh_python3-arch:
	# tweak the entry_points console_scripts list to include all supported versions
	if [ -f $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt ] ; then \
		ENTRYPOINT=$(shell ls $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt) ; \
		python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py3" "numpy.f2py.f2py2e:main" ; \
		for v in $(PY3VERS); do \
			python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py$$v" "numpy.f2py.f2py2e:main" ; \
		done \
	fi
	# Remove test artifact
	rm -f $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/xm.np.npy

MULTIARCH_TREE_DIR = $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/python3-numpy/numpy
execute_before_dh_install-arch:
	# add versioned f2pyX.Y scripts
	cp -a $(STAGING_DIR)/usr/bin/f2py $(STAGING_DIR)/usr/bin/f2py3
	# Create wrappers to run python$$i without dh-python generating a
	# hard dependency on all of those interpreters (#945824)
	set -e; for v in $(PY3VERS); do \
		sed -e "s,@VERSION@,$$v,g" debian/f2py.in > $(STAGING_DIR)/usr/bin/f2py$$v; \
		chmod 0755 $(STAGING_DIR)/usr/bin/f2py$$v; \
	done
	# Remove various LICENSE files from inconvienient locations
	find $(STAGING_DIR)/usr/lib -name "LICENSE*" -delete
	# Move NumPy headers to Multi-Arch friendly location
	mkdir -p $(MULTIARCH_TREE_DIR)/_core $(MULTIARCH_TREE_DIR)/random $(MULTIARCH_TREE_DIR)/f2py
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/_core/include $(MULTIARCH_TREE_DIR)/_core
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/_core/lib $(MULTIARCH_TREE_DIR)/_core
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/random/lib $(MULTIARCH_TREE_DIR)/random
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/f2py/src $(MULTIARCH_TREE_DIR)/f2py
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/_core/include
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/_core/lib
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/random/lib
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/f2py/src
	# Remove build path from __config__.py
	sed -i -e "s;$(CURDIR);\$$BUILDDIR;g" $(STAGING_DIR)/usr/lib/python3*/dist-packages/numpy/__config__.py
	# Remove Python version information from __config__.py
	sed -i -e '/"Python Information": {/,/},/d' $(STAGING_DIR)/usr/lib/python3*/dist-packages/numpy/__config__.py
	# Install numpy.pc for global discovery (without numpy-config shenanigans)
	mkdir -p $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	sed \
		-e "s,@VERSION@,$(shell echo $(DEB_VERSION_UPSTREAM) | cut -d+ -f1),g" \
		-e "s,@MULTIARCH@,$(DEB_HOST_MULTIARCH),g" \
		debian/numpy.pc.in > $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/numpy.pc

execute_before_dh_gencontrol:
	python3 debian/helpers/numpy_substvars.py >> debian/python3-numpy.substvars

download_remote_intersphinx_inventories:
	curl https://matplotlib.org/stable/objects.inv -o debian/intersphinx/matplotlib_objects.inv
	curl https://numpydoc.readthedocs.io/en/latest/objects.inv -o debian/intersphinx/numpydoc_objects.inv
	curl https://numpy.org/neps/objects.inv -o debian/intersphinx/neps_objects.inv
	curl https://numpy.org/numpy-tutorials/objects.inv -o debian/intersphinx/numpy-tutorials_objects.inv
	curl https://dmlc.github.io/dlpack/latest/objects.inv -o debian/intersphinx/dlpack_objects.inv
	curl https://scipy-lectures.org/objects.inv -o debian/intersphinx/scipy-lectures_objects.inv

## numpy 2.3.4%2Bds

=== debian/changelog ===
numpy (1:2.3.4+ds-3) unstable; urgency=medium

  * Fix compatibility with SWIG >= 4.4.
    Thanks to Rafael Laboissière (Closes: #1119878)

 -- Timo Röhling <roehling@debian.org>  Mon, 03 Nov 2025 16:00:11 +0100

numpy (1:2.3.4+ds-2) unstable; urgency=medium

  * Skip failing tests on riscv64

 -- Timo Röhling <roehling@debian.org>  Tue, 28 Oct 2025 22:50:45 +0100

numpy (1:2.3.4+ds-1) unstable; urgency=medium

  * New upstream version 2.3.4+ds
  * Disable version warning banner in offline documentation
  * Migrate debian/watch to version 5 format
  * Refresh patches (no functional changes)
  * Fix f2py object file handling regression with meson backend
    (Closes: #1078861)
  * Build-Depend on python3-pytz instead of deprecated python3-tz

 -- Timo Röhling <roehling@debian.org>  Tue, 28 Oct 2025 10:40:01 +0100
